library(lpSolve)

# Koeffizienten der Zielfunktion
obj <- c(320,1200,282)

# Nebenbedingungen

# Raumbeschränkung
lhs <- matrix(c(1,0,2,4,0.8,0.4),nrow=2)
rhs <- c(90,60)
dir <- c(">=",">=")

# berechne die Lösung
sol <- lp("min",obj,lhs,dir,rhs,compute.sens=T)


cat("\n\noptimale Bewertung der Ressourcen\n")
temp <- matrix(sol$solution)
rownames(temp) <- c("Raum","Zeit","Holz")
colnames(temp) <- "EUR"
print(temp)
cat("\nmin. Ressourceverbauch:",sol$objval,"\n\n")


cat("duale Variablen der Nebenbedingunge (Produktionsplan):\n")
temp <- matrix(sol$duals[1:nrow(lhs)])
rownames(temp) <- c("Tische","Sessel")
colnames(temp) <- "Anzahl"
print(temp)

cat("\nduale Variablen der Variablen (Slack):\n")
temp <- matrix(sol$duals[1:ncol(lhs)+nrow(lhs)])
rownames(temp) <- c("Raum","Zeit","Holz")
colnames(temp) <- "Slack"
print(temp)
