library(lpSolve)

# Koeffizienten der Zielfunktion
obj <- c(90,60)

# Nebenbedingungen

# Raumbeschränkung
lhs <- matrix(c(1,0),nrow=1)
rhs <- 320
dir <- "<="

# Zeitbeschränkung
lhs <- rbind(lhs,c(2,4))
rhs <- c(rhs,1200)
dir <- c(dir,"<=")

# Holzbeschränkung
lhs <- rbind(lhs,c(0.8,0.4))
rhs <- c(rhs,282)
dir <- c(dir,"<=")

# berechne die Lösung
sol <- lp("max",obj,lhs,dir,rhs,compute.sens=T)

cat("\n\noptimaler Produktionsplan\n")
temp <- matrix(sol$solution)
rownames(temp) <- c("Tische","Sessel")
colnames(temp) <- "Anzahl"
print(temp)
cat("\nmax. Zielfunktion:",sol$objval,"\n\n")

cat("duale Variablen der Nebenbedingunge (Schattenpreise):\n")
temp <- matrix(sol$duals[1:nrow(lhs)])
rownames(temp) <- paste("g",1:nrow(lhs),sep="")
colnames(temp) <- "lambda"
print(temp)

cat("\nduale Variablen der Variablen (relative Deckungsbeiträge):\n")
temp <- matrix(sol$duals[1:ncol(lhs)+nrow(lhs)])
rownames(temp) <- paste("x",1:ncol(lhs),sep="")
colnames(temp) <- "rel. Deckungsbeitrag"
print(temp)

# -------------------------
# Ändere die Deckungsbeiträge
# -------------------------

obj <- c(60,130)

cat("\n\n--------------------------------\n")
cat("Ändere die Deckungsbeiträge, sodass nur noch ein Produkt im Produktionsplan ist\n")
cat("--------------------------------\n\n")
# berechne die Lösung
sol <- lp("max",obj,lhs,dir,rhs,compute.sens=T)

cat("\n\noptimaler Produktionsplan\n")
temp <- matrix(sol$solution)
rownames(temp) <- c("Tische","Sessel")
colnames(temp) <- "Anzahl"
print(temp)
cat("\nmax. Zielfunktion:",sol$objval,"\n\n")

cat("duale Variablen der Nebenbedingungen (Schattenpreise):\n")
temp <- matrix(sol$duals[1:nrow(lhs)])
rownames(temp) <- paste("g",1:nrow(lhs),sep="")
colnames(temp) <- "lambda"
print(temp)

cat("\nduale Variablen der Variablen (relative Deckungsbeiträge):\n")
temp <- matrix(sol$duals[1:ncol(lhs)+nrow(lhs)])
rownames(temp) <- paste("x",1:ncol(lhs),sep="")
colnames(temp) <- "rel. Deckungsbeitrag"
print(temp)

