
source("plot3dTools.R")

showSurface <- TRUE
drawTangent <- TRUE
drawQuadratic <- TRUE

zmin <- -100
zmax <- 100

# draw tangent at (z1,z2,f(z1,z2))
#z1 <- 10
#z2 <- 10


# locale max
 z1 <- (30-sqrt(30))/3 
 z2 <- (30-sqrt(30))/3 

# locale min
# z1 = (30+sqrt(30))/3
# z2 = (30+sqrt(30))/3




xGrid <- (5*6):(5*14)/5
yGrid <- xGrid

f<-function(x,y){

  z <- 300 - (10 - x)^3 - 10* x - 2* (10 - y)^3 - 20* y

  return(z)

}

tangent<-function(x,y,z1,z2){
	
	fx <- matrix(c(-10+3*(10-z1)^2,-20+6*(10-z2)^2))
	
	ret <- f(z1,z2)+t(matrix(c(x,y))-matrix(c(z1,z2))) %*% fx
	
	return(ret)
	
}

quadratic<-function(x,y,z1,z2){
	
	fx <- matrix(c(-10+3*(10-z1)^2,-20+6*(10-z2)^2))
	fxx <- matrix(c(-6*(10-z1),0,0,-12*(10-z2)),nrow=2)
	
	ret <- f(z1,z2)+t(matrix(c(x,y))-matrix(c(z1,z2))) %*% fx +1/2*t(matrix(c(x,y))-matrix(c(z1,z2))) %*% fxx %*% (matrix(c(x,y))-matrix(c(z1,z2)))
	
	return(ret)
}

fGrid = matrix(0,nrow=length(xGrid),ncol=length(yGrid))

for(i in 1:length(xGrid)){
  for(j in 1:length(yGrid)){
    fGrid[i,j] <- f(xGrid[i],yGrid[j])

  }
}

tGrid <- matrix(0,nrow=length(xGrid),ncol=length(yGrid))

for(i in 1:length(xGrid)){
	for(j in 1:length(yGrid)){
		tGrid[i,j] <- tangent(xGrid[i],yGrid[j],z1,z2)
		
	}
}
tGrid[tGrid<zmin] <- zmin
tGrid[tGrid>zmax] <- zmax


qGrid <- matrix(0,nrow=length(xGrid),ncol=length(yGrid))

for(i in 1:length(xGrid)){
	for(j in 1:length(yGrid)){
		qGrid[i,j] <- quadratic(xGrid[i],yGrid[j],z1,z2)
		
	}
}
qGrid[qGrid<zmin] <- zmin
qGrid[qGrid>zmax] <- zmax



fMesh <- makeMesh(xGrid,yGrid,fGrid)
tMesh <- makeMesh(xGrid,yGrid,tGrid)
qMesh <- makeMesh(xGrid,yGrid,qGrid)

wins <- numeric()

window <- open3d()
wins <- append(wins,window)

if(showSurface){
	shade3d(fMesh,color="blue",alpha=.5,zlim=c(-100,0))
	if(drawTangent){
		shade3d(tMesh,color="grey",alpha=1.0)
	}
	if(drawQuadratic){
		shade3d(qMesh,color="grey",alpha=0.5,zlim=c(0,100))
	}
	
}


for(i in 1:length(yGrid)){
  if(yGrid[i]*2==floor(yGrid[i]*2)){
    lines3d(xGrid,yGrid[i],fGrid[,i])
  }
}
for(i in 1:length(xGrid)){
  if(xGrid[i]*2==floor(xGrid[i]*2)){
    lines3d(xGrid[i],yGrid,fGrid[i,])
  }
}

# the point of approximation
lines3d(c(z1,z1),c(z2,z2),c(zmin,zmax))


aspect3d(1,1,.5)
axes3d()
title3d(main="",ylab="Y",xlab="X")


rgl.light( theta = 50, phi = 0, viewpoint.rel = TRUE, ambient = "#FFFFFF", 
           diffuse = "#FFFFFF", specular = "#FFFFFF", x = NULL, y = NULL, z = NULL)
