MaxIter <- 1000
eps <- 1e-10


simpleNewton <- function(start,Nabla,Hesse){ # a simple Newton algorithm
	
	x <- start
	
# MaxIter is only to be sure that there is no dead-lock in case of no convergence
	for(i in 1:MaxIter){
		xnew <- x - solve(Hesse(x)) %*% Nabla(x)
		print(xnew)
		print(max(abs(xnew-x))<eps)
		if(max(abs(xnew-x))<eps){
			break
		}
		x <- xnew
	}
	
	return(xnew)
	
}


# take the example f(x1,x2)=300-(10-x1)^3-10x1 -2(10-x2)^3-20x2

gradient <- function(x){

	return(matrix(c(3*(10-x[1,1])^2-10,6*(10-x[2,1])^2-20)))

}

hesse <- function(x){

	return(diag(c(-6*(10-x[1,1]),-12*(10-x[2,1]))))
	
}

StartSol=matrix(c(0,0))


findCandidate <- function(Start){

	approx=simpleNewton(Start,gradient,hesse)
	print(format(approx,digits=10))
        return(approx)
}

